<template lang="pug">
  div

    // tabs
    div(class="tabs")
      a(v-on:click="activetab=1" v-bind:class="[ activetab === 1 ? 'active' : '' ]") Vehicle Insurance
      a(v-on:click="activetab=2" v-bind:class="[ activetab === 2 ? 'active' : '' ]") Home Insurance

    p(v-if="errors.length")
      b Please correct the following error(s):
      ul
        li(v-for="error in errors") {{ error }}


    // ---------------------------------- Driver Insurance
    div(v-if="activetab === 1")
      h1 Driver Insurance
      h4 Primary Driver Details

      form(class="form-group")
        p
          input(
            class="form-control"
            type="text"
            v-model="vehicleForm.primaryDriver.fullName" 
            placeholder="Full Name"
          )
        p
          input(
            class="form-control"
            type="text"
            v-model="vehicleForm.primaryDriver.driversLicense" 
            placeholder="Drivers License"
          )
        p
          textarea(
            class="form-control"
            v-model="vehicleForm.primaryDriver.mailingAddress" 
            placeholder="Mailing Address"
          )
        p
          input(
            class="form-control"
            type="text"
            v-model="vehicleForm.primaryDriver.dateOfBirth" 
            placeholder="Date Of Birth"
          )
      
        p Have you received any tickets in the previous 3 years?
        p
          div(class="form-check form-check-inline")
            input(v-model="vehicleForm.primaryDriver.tickets" class="form-check-input" type="radio" id="driver1_tickets_yes" v-bind:value="true")
            label(class="form-check-label" for="driver1_tickets_yes") Yes

          div(class="form-check form-check-inline")
            input(v-model="vehicleForm.primaryDriver.tickets" class="form-check-input" type="radio" id="driver1_tickets_no" v-bind:value="false")
            label(class="form-check-label" for="driver1_tickets_no") No

        h4 Additional Drivers
        div(v-for="(driver, index) in vehicleForm.additionalDrivers")

          hr

          h4 Driver {{ index + 2 }} Details 
            span(class="btn btn-danger" @click="removeDriver(index)") Remove
          p
            input(
              class="form-control"
              type="text"
              v-model="driver.fullName"
              placeholder="Full Name"
            )

          p
            input(
              class="form-control"
              type="text"
              v-model="driver.driversLicense"
              placeholder="Drivers License"
            )
          
          p
            textarea(
              class="form-control"
              v-model="driver.mailingAddress"
              placeholder="Mailing Address"
            )
          
          p
            input(
              class="form-control"
              type="text"
              v-model="driver.dateOfBirth"
              placeholder="Date Of Birth"
            )

          p Driver {{ index + 2 }}: Any tickets in the previous 3 years?
          p
            div(class="form-check form-check-inline")
              input(v-model="driver.tickets" class="form-check-input" type="radio" :id="'driver'+index+'_tickets_yes'" v-bind:value="true")
              label(class="form-check-label" for="tickets_yes") Yes

            div(class="form-check form-check-inline")
              input(v-model="driver.tickets" class="form-check-input" type="radio" :id="'driver'+index+'_tickets_no'" v-bind:value="false")
              label(class="form-check-label" for="tickets_no") No

        h4(class="btn btn-success" @click="addDriver()") Add Driver

        h4 Vehicles
        div(v-for="(vehicle, index) in vehicleForm.vehicles")

          hr

          h4 Vehicle {{ index + 1 }} Details 
            span(class="btn btn-danger" @click="removeVehicle(index)") Remove
          p
            input(
              class="form-control"
              type="text"
              v-model="vehicle.vin"
              placeholder="VIN"
            )

          p
            input(
              class="form-control"
              type="text"
              v-model="vehicle.year"
              placeholder="Vehicle Year"
            )
          
          p
            input(
              class="form-control"
              type="text"
              v-model="vehicle.make"
              placeholder="Make"
            )
          
          p
            input(
              class="form-control"
              type="text"
              v-model="vehicle.model"
              placeholder="Model"
            )
          
          p Type of Coverage Required
          p
            select(v-model="vehicle.coverage" class="form-control")
              option(
                v-for="(item, index) in vehicleCoverage"
                :key="index"
                :value="item"
              ) {{ item }}

          p Use
          p
            select(v-model="vehicle.use" class="form-control")
              option(
                v-for="(item, index) in vehicleUse"
                :key="index"
                :value="item"
              ) {{ item }}
          
        
        h4(class="btn btn-success" @click="addVehicle()") Add Vehicle
        
        p Does your health insurance provider cover medical issues from an auto accident?
          div(class="form-check form-check-inline")
            input(v-model="vehicleForm.medicalCoverage" class="form-check-input" type="radio" :id="medical_overage_yes" v-bind:value="true")
            label(class="form-check-label" for="medical_coverage_yes") Yes

          div(class="form-check form-check-inline")
            input(v-model="vehicleForm.medicalCoverage" class="form-check-input" type="radio" :id="medical_overage_no" v-bind:value="false")
            label(class="form-check-label" for="medical_coverage_no") No

        p What is your current Billing cycle?
        p 
          select(v-model="vehicleForm.currentBilling", class="form-control")
            option(
              v-for="(item, index) in billing"
              :key="index"
              :value="item"
            ) {{ item }}
        
        hr

        h4(class="btn btn-primary" @click="submit(vehicleForm)") Submit

    // ----------------------------------------- Home Insurance
    div(v-if="activetab === 2")
      h1 Home Insurance
      h4 Your Home Details
      form(class="form-group")
        p
          input(
            class="form-control"
            type="text"
            v-model="homeForm.fullName"
            placeholder="Full Name"
          )

      p
        input(
          class="form-control"
          type="text"
          v-model="homeForm.address"
          placeholder="Your Address"
        )

      p
        input(
          class="form-control"
          type="number"
          v-model="homeForm.age"
          placeholder="Age in years"
          min="0"
          max="150"
        )
      
      p
        textarea(
          class="form-control"
          v-model="homeForm.items"
          placeholder="Do you have jewelry, boats, trailers, or large personal items to insure? List them, and amounts of desired coverage on each"
        )

      p Do you have a Basement at this address?
      p
        div(class="form-check form-check-inline")
          input(v-model="homeForm.basementExists" class="form-check-input" type="radio" id="basement_yes" v-bind:value="true")
          label(class="form-check-label" for="basement_yes") Yes

        div(class="form-check form-check-inline")
          input(v-model="homeForm.basementExists" class="form-check-input" type="radio" id="basement_no" v-bind:value="false")
          label(class="form-check-label" for="basement_no") No

      p What percentage of the basement is finished?
      p
        input(
          class="form-control"
          type="number"
          v-model="homeForm.basementPercentFinished"
          placeholder="%"
          min="0"
          max="100"
        )

      p Have you made any claims in the last 3 years?
      p
        div(class="form-check form-check-inline")
          input(v-model="homeForm.recentClaims" class="form-check-input" type="radio" id="claims_yes" v-bind:value="true")
          label(class="form-check-label" for="claims_yes") Yes

        div(class="form-check form-check-inline")
          input(v-model="homeForm.recentClaims" class="form-check-input" type="radio" id="claims_no" v-bind:value="false")
          label(class="form-check-label" for="claims_no") No

      p
        textarea(
          class="form-control"
          v-model="homeForm.recentLoss"
          placeholder="Have you had any recent losses? Details..."
        )

      p Is there a wood stove at this address?
      p
        div(class="form-check form-check-inline")
          input(v-model="homeForm.woodStove" class="form-check-input" type="radio" id="woodStove_yes" v-bind:value="true")
          label(class="form-check-label" for="woodStove_yes") Yes

        div(class="form-check form-check-inline")
          input(v-model="homeForm.woodStove" class="form-check-input" type="radio" id="woodStove_no" v-bind:value="false")
          label(class="form-check-label" for="woodStove_no") No

      p What is your current Billing cycle?
      p 
        select(v-model="homeForm.currentBilling", class="form-control")
          option(
            v-for="(item, index) in billing"
            :key="index"
            :value="item"
          ) {{ item }}

      h4(class="btn btn-primary" @click="submit(homeForm)") Submit

</template>

<script>
import axios from 'axios'


function Driver () {
  this.fullName = '',
  this.driversLicense = '',
  this.mailingAddress = '',
  this.dateOfBirth = '',
  this.tickets = false
}

function Vehicle () {
  this.vin = '',
  this.year = '',
  this.make = '',
  this.model = '',
  this.coverage = 'full',
  this.use = 'home'
}

// TODO: use capitalize filter for labels

export default {
  created () {
  },
  data () {
    let self = this;
    return {
      errors: [],
      activetab: 1,
      billing: [
        'annually',
        'bi-anually',
        'quaterly',
        'monthly',
        'eft'
      ],
      vehicleCoverage: [
        'full',
        'PLPD'
      ],
      vehicleUse: [
        'home',
        'school'
      ],
      vehicleForm: {
        type: 'vehicle',
        primaryDriver: new Driver(),
        additionalDrivers: [], // array of Driver objects
        collegeGrads: false,
        collegeGradsDetails: '', // list of names
        vehicles: [],
        medicalCoverage: false,
        coverage: '',
        use: '',
        currentBilling: 'annually' // billing Array
      },
      homeForm: {
        type: 'home',
        age: '',
        address: '',
        items: '', // large text box
        basementExists: false,
        basementPercentFinished: 0,
        recentClaims: false,
        recentLoss: '',  // large text box
        woodStove: false,
        currentBilling: 'annually' // billing Array
      },
      billing: [
        'annually',
        'bi-anually',
        'quaterly',
        'monthly',
        'eft'
      ]
    }
  },
  watch: {
    vehicleForm: {
      handler: function(newValue) {
        console.log('vehicleForm', this.vehicleForm);
      },
      deep: true
    },
  },
  methods: {
    submit: function (form) {
      // validate
      if(form.type === 'vehicle' && !this.validateVehicleForm()) return false;
      if(form.type === 'home' && !this.validateHomeForm()) return false;

      let url = '/save';
      axios.post(url, {
        data: form,
        headers: {
          'content-type': 'application/json',
        },
      })
      .then(function (response) {
        console.log('response', response);
      })
      .catch(function (error) {
        console.log('error', error);
      });
    },
    addDriver: function () {
      this.vehicleForm.additionalDrivers.push(new Driver());
    },
    addVehicle: function () {
      this.vehicleForm.vehicles.push(new Vehicle());
    },
    removeDriver: function (index) {
      this.vehicleForm.additionalDrivers.splice(index, 1);
    },
    removeVehicle: function (index) {
      this.vehicleForm.vehicles.splice(index, 1);
    },
    validateVehicleForm: function () {
      this.errors = [];
      if (!this.vehicleForm.primaryDriver.fullName) {
        this.errors.push('Full Name required.');
      }
      if (!this.vehicleForm.primaryDriver.dateOfBirth) {
        this.errors.push('Age required.');
      }
      return (this.errors.length < 1) ? true : false;
    },
    validateHomeForm: function () {
      this.errors = [];
      if (!this.homeForm.fullName) {
        this.errors.push('Full Name required.');
      }
      if (!this.homeForm.age) {
        this.errors.push('Age required.');
      }
      return (this.errors.length < 1) ? true : false;
    }
  },
  filters: {
    capitalize: function (str) {
      return str.charAt(0).toUpperCase() + str.slice(1)
    },
  }
}
</script>
<style scoped>
.button {
  width: 40%;
}
h1 {
  margin: 30px 0px;
}

/* Style the tabs */
.tabs {
    overflow: hidden;
    margin-left: 0px;
    margin-bottom: -2px; /* hide bottom border */
}

.tabs ul {
    list-style-type: none;
    margin-left: 20px;
}

.tabs a{
    float: left;
    cursor: pointer;
    padding: 12px 24px;
    transition: background-color 0.2s;
    border: 1px solid #ccc;
    border-right: none;
    background-color: #f1f1f1;
    border-radius: 10px 10px 0 0;
    font-weight: bold;
}
.tabs a:last-child { 
    border-right: 1px solid #ccc;
}

/* Change background color of tabs on hover */
.tabs a:hover {
    background-color: #aaa;
    color: #fff;
}

/* Styling for active tab */
.tabs a.active {
    background-color: #fff;
    color: #484848;
    border-bottom: 2px solid #fff;
    cursor: default;
}

</style>